/*
 * SourceMod Radio
 *
 * Adds a radio player to SourceMod that supports direct station links or streaming audio
 *
 * Coded by dubbeh - www.dubbeh.net
 *
 * Licensed under the GPLv3
 *
 */

Handle g_hCookieSavedStationID = INVALID_HANDLE;
Handle g_hCookieSavedVolumeLevel = INVALID_HANDLE;
Handle g_hCookieRadioPlayType = INVALID_HANDLE;
Handle g_hCookieIsCustomShoutCast = INVALID_HANDLE;

methodmap ClientCookies
{
	public void Init ()
	{
		g_hCookieSavedStationID = RegClientCookie("Radio Station ID", "Radio saved station ID", CookieAccess_Private);
		g_hCookieSavedVolumeLevel = RegClientCookie("Radio Volume Level", "Radio saved volume level", CookieAccess_Private);
		g_hCookieRadioPlayType = RegClientCookie("Radio Play Type", "Play type with the stored cookie", CookieAccess_Private);
		g_hCookieIsCustomShoutCast = RegClientCookie("Radio Custom ShoutCast", "Is this a custom ShoutCast station", CookieAccess_Private);
	}

	public int GetID(int iClient)
	{
		char szID[12] = "";
		
		GetClientCookie(iClient, g_hCookieSavedStationID, szID, sizeof(szID));
		return StringToInt(szID);
	}

	public void SetID(int iClient, char []szStationID)
	{
		SetClientCookie(iClient, g_hCookieSavedStationID, szStationID);
	}

	public bool GetIsCustom (int iClient)
	{
		char szIsCustom[12] = "";
		
		GetClientCookie(iClient, g_hCookieIsCustomShoutCast, szIsCustom, sizeof(szIsCustom));
		return view_as<bool>(StringToInt(szIsCustom));
	}

	public void SetIsCustom(int iClient, char []szIsCustom)
	{
		SetClientCookie(iClient, g_hCookieIsCustomShoutCast, szIsCustom);
	}

	public int GetPlayType(int iClient)
	{
		char szPlayType[12] = "";
		
		GetClientCookie(iClient, g_hCookieRadioPlayType, szPlayType, sizeof(szPlayType));
		return StringToInt(szPlayType);
	}

	public void SetPlayType(int iClient, char []szPlayType)
	{
		SetClientCookie(iClient, g_hCookieRadioPlayType, szPlayType);
	}

	public void SetVolume(int iClient, char []szVolume)
	{
		SetClientCookie(iClient, g_hCookieSavedVolumeLevel, szVolume);
	}
	
	public void GetVolume(int iClient, char []szVolumeBuffer, int iVolumeBufferSize)
	{
		char szSavedVolume[10] = "";
		float fVolume = 0.0;
		
		GetClientCookie(iClient, g_hCookieSavedVolumeLevel, szSavedVolume, sizeof(szSavedVolume));
		if (!szSavedVolume[0])
		{
			fVolume = g_cVarInitialConnectVolume.FloatValue;
			FloatToString(fVolume, szSavedVolume, sizeof(szSavedVolume));
			this.SetVolume(iClient, szSavedVolume);
		}
		
		strcopy(szVolumeBuffer, iVolumeBufferSize, szSavedVolume);
	}
}
